local _, iTF = ...

--Defaults iTFConfig.layout.frame.spacing = 4
-- iTFConfig.layout.frame.height = 50
-- iTFConfig.layout.frame.castBarHeight = 25
-- iTFConfig.layout.statusbar.castBarHeight
function iTF:LoadDefaults(force)
	if not iTFConfig.bindings then --first run
		iTFConfig.bindings = {
			['general'] = {
				['LeftButton'] = {
					['type'] = 'target',
				},
			},
		}
	end
	local defaults = iTF:GetProfile()
	if force then
		if iTFConfig.frame then
			iTFConfig = nil
			iTFConfig = {}
		end
		iTFConfig.layout = defaults
		iTF:updateFrames('conditionals')
	else
		if not iTFConfig.layout then
			iTFConfig.layout = {}
		end
		for k,v in pairs(defaults) do
			if iTFConfig.layout[k] == nil then
				iTFConfig.layout[k] = v
			elseif type(v) == 'table' then
				for deeperKey, deeperValue in pairs(v) do
					if iTFConfig.layout[k][deeperKey] == nil then
						iTFConfig.layout[k][deeperKey] = deeperValue
					elseif type(deeperValue) == 'table' then
						for inceptionLevelKey, inceptionLevelValue in pairs(deeperValue) do
							if iTFConfig.layout[k][deeperKey][inceptionLevelKey] == nil then
								iTFConfig.layout[k][deeperKey][inceptionLevelKey] = inceptionLevelValue
							elseif type(inceptionLevelValue) == 'table' then
								for wtfKey, wtfValue in pairs(inceptionLevelValue) do
									if wtfKey == 'color' then --Don't override indicators, indicators and colors should be only one this deep
										if iTFConfig.layout[k][deeperKey][inceptionLevelKey][wtfKey] == nil then
											iTFConfig.layout[k][deeperKey][inceptionLevelKey][wtfKey] = wtfValue
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
	if iTFConfig.frame then
		iTF:print('WTF layout has changed, use "/itf reset" to delete old settings and reset to defaults')
	end
end
local function loadProfile(profile)
	if profile == 'default' then
		iTF:LoadDefaults(true)
	end
end
local function GetValues(get)
	if get == 'all' then
		return {['TOPLEFT'] = 'Top left', ['TOPRIGHT'] = 'Top right', ['TOP'] = 'Top', ['LEFT'] = 'Left', ['CENTER'] = 'Center', ['RIGHT'] = 'Right', ['BOTTOMRIGHT'] = 'Bottom right', ['BOTTOMLEFT'] = 'Bottom left', ['BOTTOM'] = 'Bottom'}
	elseif get == 'grow' then
		return {['LEFT'] = 'Right', ['RIGHT'] = 'Left', ['TOP'] = 'Bottom', ['BOTTOM'] = 'Top'}
	elseif get == 'ind' then
		return {['glowLeft'] = 'Glow: Left', ['glowRight'] = 'Glow: Right', ['glowTop'] = 'Glow: Top', ['glowBottom'] = 'Glow: Bottom', ['border'] = 'Border', ['statusbar'] = 'Status bar color', ['alpha'] = 'Frame Opacity'}
	end
end
local function MainFrameBG(show)
	if show then
		iTF.mainFrame.tex:Show()
		iTF.show = true
	else
		iTF.mainFrame.tex:Hide()
		iTF.show = nil
	end
end
local profileListing = {}
local function GetProfiles()
	profileListing = iTF:GetProfileList()
	return profileListing
end
--function iTF:loadOptions()
local currentlySelectedKeyMode = 1
local castType = 1
local textToAdd
local toAdd
local keyToAdd
local bindings = {}
local totalFrames = 0
local customCondTemp = {}
local function bindingOptions(optionsToShow)
	if not iTF_BindingsFrame then --Create frames
		local width = 300
		local font = 'Fonts\\ARIALN.TTF'
		local f = CreateFrame('frame', 'iTF_BindingsFrame', UIParent)
		f:SetSize(width,500)
		f:SetPoint('CENTER', UIParent, 'CENTER', 0,0)
		--f.tex = f:CreateTexture()
		--f.tex:SetAllPoints(f)
		--f.tex:SetColorTexture(0.2,0.2,0.2,0.75)
		f:SetBackdrop({bgFile = 'Interface\\Buttons\\WHITE8x8',edgeFile = 'Interface\\Buttons\\WHITE8x8',edgeSize = 1,insets = {left = -1,right = -1,top = -1,bottom = -1,}})
		f:SetBackdropColor(0.1,0.1,0.1,0.9)
		f:SetBackdropBorderColor(0,0,0,1)
		f:SetFrameStrata('HIGH')
		f:SetMovable(true)
		f:Show()
		tinsert(UISpecialFrames, 'iTF_BindingsFrame') --Close on escape
		--Title
		f.title = CreateFrame('frame', nil, f)
		f.title:SetSize(width, 20)
		f.title:SetBackdrop({bgFile = 'Interface\\Buttons\\WHITE8x8',edgeFile = 'Interface\\Buttons\\WHITE8x8',edgeSize = 1,insets = {left = -1,right = -1,top = -1,bottom = -1,}})
		f.title:SetBackdropColor(0.1,0.1,0.1,0.9)
		f.title:SetBackdropBorderColor(0,0,0,1)
		f.title:SetPoint('BOTTOM', f, 'TOP', 0, 1)
		f.title:EnableMouse(true)
		f.title:SetScript('OnMouseDown', function(self,button)
			f:ClearAllPoints()
			f:StartMoving()
		end)
		f.title:SetScript('OnMouseUp', function(self, button)
			f:StopMovingOrSizing()
		end)
		f.titleText = f.title:CreateFontString('iTargetingFrames_BindingsTitleText')
		f.titleText:SetFont(font, 12, 'OUTLINE')
		f.titleText:SetPoint('CENTER', f.title, 'CENTER', 0,0)
		f.titleText:SetText('iTargetingFrames')
		f.exit = CreateFrame('BUTTON', nil, f)
		f.exit:SetSize(18, 18)
		f.exit:SetBackdrop({bgFile = 'Interface\\Buttons\\WHITE8x8',edgeFile = 'Interface\\Buttons\\WHITE8x8',edgeSize = 1,insets = {left = -1,right = -1,top = -1,bottom = -1,}})
		f.exit:SetBackdropColor(0.1,0.1,0.1,0.9)
		f.exit:SetBackdropBorderColor(0.8,0,0,1)
		f.exit:SetPoint('TOPRIGHT', f.title, 'TOPRIGHT', -1,-1)
		f.exit:RegisterForClicks('AnyUp')
		f.exit:SetFrameStrata('DIALOG')
		f.exit:SetScript('OnClick', function()
			bindingOptions()
		end)
		f.exit.text = f.exit:CreateFontString()
		f.exit.text:SetFont(font, 12, 'OUTLINE')
		f.exit.text:SetPoint('CENTER', f.exit, 'CENTER',0,0)
		f.exit.text:SetText('X')

	end
	local i = 0
	function bindings.add(key, type,textToAdd)
		if not bindings.frame then
			bindings.frame = {}
		end
		i = i + 1
		if not bindings.frame['delButton' .. i] then
			if i > totalFrames then
				totalFrames = i
			end
			bindings.frame['delButton' .. i] = CreateFrame('BUTTON', nil, iTF_BindingsFrame, 'OptionsButtonTemplate')
			bindings.frame['delButton' .. i]:SetSize(20,20)
			bindings.frame['delButton' .. i]:SetText('X')
			bindings.frame['delButton' .. i]:Show()
			local y = 20*i+1
			bindings.frame['delButton' .. i]:SetPoint('BOTTOMLEFT', 'iTF_BindingsFrame', 'TOPLEFT', 1, -y)
			bindings.frame['delButton' .. i].text = bindings.frame['delButton' .. i]:CreateFontString()
			bindings.frame['delButton' .. i].text:SetFont('Fonts\\ARIALN.TTF', 12, 'OUTLINE')
			bindings.frame['delButton' .. i].text:SetPoint('LEFT', bindings.frame['delButton' .. i], 'RIGHT', 0, 0)
			bindings.frame['delButton' .. i].text:SetJustifyH('LEFT')
			bindings.frame['delButton' .. i].text:SetWidth(278)
		end
		bindings.frame['delButton' .. i]:SetScript('OnClick', function()
			if optionsToShow == 'class' then
				iTFConfig.bindings[iTF.class].b[key] = nil
			elseif optionsToShow == 'spec' then
				iTFConfig.bindings[iTF.class][iTF.specID][key] = nil
			else
				iTFConfig.bindings.general[key] = nil
			end
			iTF:updateFrames('bindings')
			i = 0
			bindings.update()
		end)
		bindings.frame['delButton' .. i]:Show()
		if textToAdd then
			bindings.frame['delButton' .. i].text:SetText(string.format([[%s (%s): %s]],key,type,textToAdd))
		else
			bindings.frame['delButton' .. i].text:SetText(string.format([[%s: %s]],key,type))
		end
		
		
	end
	--addBinding('LeftButton','Spell','Stuff')
	function bindings.update()
		--loop trough options & show
		local tableToLoop
		local titleText = 'iTargetingFrames : '
		if optionsToShow == 'general' then
			tableToLoop = iTFConfig.bindings.general
			titleText = titleText .. 'General'
		elseif optionsToShow == 'class' then
			tableToLoop = iTFConfig.bindings[iTF.class].b
			titleText = titleText .. GetClassInfo(iTF.class)
		else --spec
			tableToLoop = iTFConfig.bindings[iTF.class][iTF.specID]
			titleText = titleText .. select(2,GetSpecializationInfoByID(iTF.specID))			
		end
		for k,v in pairs(tableToLoop) do
			bindings.add(k, v.type, v.text)
		end
		for k = i+1, totalFrames do -- Hide unused frames
			bindings.frame['delButton' .. k]:Hide()
		end
		--update title text
		
		iTargetingFrames_BindingsTitleText:SetText(titleText)
	end
	if optionsToShow then
		--Show
		--updateBindings()
		bindings.update()
		iTF_BindingsFrame:Show()
	else
		--hide()
		iTF_BindingsFrame:Hide()
	end	
end
local function getArgs(name)
	local args = {
		addNewHeader = {
			type = 'header',
			name = 'Add New Binding',
			order = 1,
		},
		bindingType = {
			name = 'Key type',
			desc = 'Key type',
			order = 2,
			type = 'select',
			values = {'Keyboard','LeftButton','RightButton', 'Mouse wheel down', 'Mouse wheel up'},
			get = function(info)
				return currentlySelectedKeyMode 
			end,
			set = function(info,val)
				currentlySelectedKeyMode = val
				if currentlySelectedKeyMode == 2 then
					keyToAdd = 'LeftButton'
				elseif currentlySelectedKeyMode == 3 then
					keyToAdd = 'RightButton'
				elseif currentlySelectedKeyMode == 4 then
					keyToAdd = 'MouseWheelDown'
				elseif currentlySelectedKeyMode == 5 then
					keyToAdd = 'MouseWheelDown'
				end
			end,
		},
		binding = {
			name = 'Key',
			desc = 'bindings',
			order = 3,
			hidden = function()
				if currentlySelectedKeyMode == 1 then
					return false
				else
					return true
				end
			end,
			type = 'keybinding',
			set = function(info,val)
				keyToAdd = tostring(val)
			end,
			get = function(info)
				return keyToAdd
			end,
		},
		type = {
			name = 'Type',
			desc = 'TO DO',
			order = 4,
			type = 'select',
			values = {'Spell', 'Macro', 'Target', 'Focus','Raid Icon: |TInterface\\TargetingFrame\\UI-RaidTargetingIcon_1:0|t', 'Raid Icon: |TInterface\\TargetingFrame\\UI-RaidTargetingIcon_2:0|t', 'Raid Icon: |TInterface\\TargetingFrame\\UI-RaidTargetingIcon_3:0|t', 'Raid Icon: |TInterface\\TargetingFrame\\UI-RaidTargetingIcon_4:0|t', 'Raid Icon: |TInterface\\TargetingFrame\\UI-RaidTargetingIcon_5:0|t', 'Raid Icon: |TInterface\\TargetingFrame\\UI-RaidTargetingIcon_6:0|t', 'Raid Icon: |TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:0|t', 'Raid Icon: |TInterface\\TargetingFrame\\UI-RaidTargetingIcon_8:0|t', 'Raid Icon: Clear'},
			get = function(info) return castType end,
			set = function (info, val) 
				castType = val
			end,
		},
		spellName = {
			name = 'Spell name',
			desc = 'Spell name',
			order = 5,
			type = 'input',
			hidden = function()
				if castType == 1 then
					return false
				else
					return true
				end					
			end,
			set = function(info,val)
				textToAdd = val
			end,
			get = function(info) 
				return textToAdd
			end,
		},
		macroText = {
			name = 'Macro text',
			desc = 'Macro text',
			order = 5,
			type = 'input',
			multiline = true,
			width = 'full',
			hidden = function()
				if castType == 2 then
					return false
				else
					return true
				end					
			end,
			set = function(info,val)
				textToAdd = val
			end,
			get = function(info) 
				return textToAdd
			end,
		},
		addNew = {
			name = 'Add New',
			desc = 'Add new binding',
			order = 6,
			width = 'full',
			type = 'execute',
			func = function()
				if keyToAdd then
					local typeToAdd
					if castType == 1 then
						typeToAdd = 'spell'
					elseif castType == 3 then
						typeToAdd = 'target'
						textToAdd = nil
					elseif castType == 4 then
						typeToAdd = 'focus'
						textToAdd = nil
					else
						typeToAdd = 'macro'
						if castType == 13 then
							textToAdd = [[/script SetRaidTarget('mouseover', 0)]]
						elseif castType >= 5 then
							textToAdd = string.format([[/script SetRaidTarget('mouseover', %s)]], castType-4)
						end
					end
					local binding = {['type'] = typeToAdd}
					if textToAdd then -- don't add text for target (and maybe for some future stuff)
						binding.text = textToAdd
					end
					if name == 'class' then
						iTFConfig.bindings[iTF.class].b[keyToAdd] = binding
						iTF:updateFrames('bindings')
						if iTF_BindingsFrame and iTF_BindingsFrame:IsShown() then
							bindingOptions('class')
						end
					elseif name == 'spec' then
						iTFConfig.bindings[iTF.class][iTF.specID][keyToAdd] = binding
						iTF:updateFrames('bindings')
						if iTF_BindingsFrame and iTF_BindingsFrame:IsShown() then
							bindingOptions('spec')
						end
					elseif name == 'general' then
						iTFConfig.bindings.general[keyToAdd] = binding
						iTF:updateFrames('bindings')
						if iTF_BindingsFrame and iTF_BindingsFrame:IsShown() then
							bindingOptions('general')
						end
					end
				end
			end,
		},
		currentBindings = {
			name = 'Current Bindings',
			order = 7,
			width = 'full',
			type = 'execute',
			func = function()
				bindingOptions(name)
			end,
		},
	}
	return args
end

function iTF:loadOptions()
	--if not iTFConfig then return { name = 'iTargetingFrames', type = 'group', args = {}}  end
	local options = {
		type = "group",
		args = {
			ShowBackground = {
				name = 'Show background',
				desc = 'Show max size',
				type = 'toggle',
				set = function(info,val) MainFrameBG(val) end,
				get = function(info) return iTF.show end
			},
			--[[
			toggleLock = {
				name = 'Toggle Lock',
				desc = 'lock frame',
				type = 'toggle',
				set = function(info,val) MainFrameBG(val) end,
				get = function(info) return iTF.show end
			},
			--]]
			frameOptions={
				name = 'Frame',
				type = 'group',
				order = 1,
				args = {
					xPos = {
						name = 'Horizontal position',
						desc = 'Horizontal position',
						type = 'range',
						order = 1,
						min = 0,
						max = math.floor(GetScreenWidth()),
						step = 1,
						
						set = function(info,val)
							iTFConfig.layout.anchor.x = val
							iTF:updateFrames('pos')
						end,
						get = function(info) return iTFConfig.layout.anchor.x end
					},
					yPos = {
						name = 'Vertical position',
						desc = 'Vertical position',
						type = 'range',
						order = 2,
						min = 0,
						max = math.floor(GetScreenHeight()),
						step = 1,
						set = function(info,val)
							iTFConfig.layout.anchor.y = val
							iTF:updateFrames('pos')
						end,
						get = function(info) return iTFConfig.layout.anchor.y end
					},
					rows = {
						name = 'Rows',
						desc = 'Row size',
						type = 'range',
						order = 3,
						min = 1,
						max = 30,
						step = 1,
						set = function(info,val)
							iTFConfig.layout.colS = val
							iTF:updateFrames('pos')
						end,
						get = function(info) return iTFConfig.layout.colS end
					},
					grow = {
						name = 'Grow',
						desc = 'Grow to',
						type = 'select',
						order = 4,
						values = {['TOPRIGHT'] = 'Down & Left', ['TOPLEFT'] = 'Down & Right', ['BOTTOMRIGHT'] = 'Up & Left', ['BOTTOMLEFT'] = 'Up & Right'},
						set = function(info,val)
							iTFConfig.layout.grow = val
							iTF:updateFrames('pos')
						end,
						get = function(info) return iTFConfig.layout.grow end
					},
					spacing = {
						name = 'Spacing',
						desc = 'frameSpacing',
						type = 'range',
						order = 5,
						min = 2,
						max = 100,
						step = 1,
						set = function(info,val)
							iTFConfig.layout.frame.spacing = val
							iTF:updateFrames('pos')
						end,
						get = function(info) return iTFConfig.layout.frame.spacing end
					},
					size = {
						name = 'Size',
						type = 'group',
						order = 1,
						args = {
							width = {
								name = 'Width',
								desc = 'Unit frame width',
								type = 'range',
								order = 1,
								min = 10,
								max = 200,
								step = 1,
								
								set = function(info,val)
									iTFConfig.layout.frame.width = val
									iTF:updateFrames('size')
								end,
								get = function(info) return iTFConfig.layout.frame.width end
							},
							height = {
								name = 'Height',
								desc = 'Unit frame height',
								type = 'range',
								order = 2,
								min = 10,
								max = 200,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.frame.height = val
									iTF:updateFrames('size')
								end,
								get = function(info) return iTFConfig.layout.frame.height end
							},
						},
					},
					text = {
						name = 'Text',
						type = 'group',
						order = 2,
						args = {
							size = {
								name = 'Size',
								desc = 'Font size',
								type = 'range',
								order = 1,
								min = 5,
								max = 50,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.text.size = val
									iTF:updateFrames('text')
								end,
								get = function(info) return iTFConfig.layout.text.size end
							},
							textPosition = {
								name = 'Text Position',
								desc = 'Text Position',
								type = 'select',
								order = 2,
								values = {['TOPLEFT'] = 'Top left', ['TOPRIGHT'] = 'Top right', ['TOP'] = 'Top', ['LEFT'] = 'Left', ['CENTER'] = 'Center', ['RIGHT'] = 'Right', ['BOTTOMRIGHT'] = 'Bottom right', ['BOTTOMLEFT'] = 'Bottom left', ['BOTTOM'] = 'Bottom'},
								set = function(info,val)
									iTFConfig.layout.text.pos = val
									iTF:updateFrames('text')
								end,
								get = function(info) return iTFConfig.layout.text.pos end
							},
							horizontal = {
								name = 'Horizontal position',
								desc = 'Horizontal position',
								type = 'range',
								order = 3,
								min = -50,
								max = 50,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.text.x = val
									iTF:updateFrames('text')
								end,
								get = function(info) return iTFConfig.layout.text.x end
							},
							vertical = {
								name = 'Vertical position',
								desc = 'Vertical position',
								type = 'range',
								order = 4,
								min = -50,
								max = 50,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.text.y = val
									iTF:updateFrames('text')
								end,
								get = function(info) return iTFConfig.layout.text.y end
							},
							nameColor = {
								name = 'Name color',
								desc = 'Name text color',
								type = 'color',
								order = 5,
								hasAlpha = true,
								set = function(info,r,g,b,a)
									iTFConfig.layout.colors.text.main = {r,g,b,a}
									iTF:updateFrames('text')
								end,
								get = function(info)
									return unpack(iTFConfig.layout.colors.text.main)
								end,
							},
							castColor = {
								name = 'Cast color',
								desc = 'Cast text color',
								type = 'color',
								order = 6,
								hasAlpha = true,
								set = function(info,r,g,b,a)
									iTFConfig.layout.colors.text.cast = {r,g,b,a}
									iTF:updateFrames('text')
								end,
								get = function(info)
									return unpack(iTFConfig.layout.colors.text.cast)
								end,
							},
							immuneColor = {
								name = 'Non interruptible color',
								desc = 'Non interruptible cast text color',
								type = 'color',
								order = 7,
								hasAlpha = true,
								set = function(info,r,g,b,a)
									iTFConfig.layout.colors.text.immune = {r,g,b,a}
									iTF:updateFrames('text')
								end,
								get = function(info)
									return unpack(iTFConfig.layout.colors.text.immune)
								end,
							},
						},
					},
					castBar = {
						name = 'Cast bar',
						type = 'group',
						order = 3,
						args = {
							height = {
								name = 'Height',
								desc = 'Cast bar height',
								type = 'range',
								order = 1,
								min = 1,
								max = 60,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.frame.castBarHeight = val
									iTF:updateFrames('size')
								end,
								get = function(info) return iTFConfig.layout.frame.castBarHeight end
							},
							color = {
								name = 'Cast bar color',
								desc = 'Cast bar color',
								type = 'color',
								order = 2,
								hasAlpha = true,
								set = function(info,r,g,b,a)
									iTFConfig.layout.colors.statusbar.cast = {r,g,b,a}
									iTF:updateFrames('castBarColor')
								end,
								get = function(info)
									return unpack(iTFConfig.layout.colors.statusbar.cast)
								end,
							},
						},
					},
					statusbar = {
						name = 'Health bar',
						type = 'group',
						order = 2,
						args = {
							color = {
								name = 'Bar color',
								desc = 'Bar color',
								type = 'color',
								order = 1,
								hasAlpha = true,
								set = function(info,r,g,b,a)
									iTFConfig.layout.colors.statusbar.main = {r,g,b,a}
									iTF:updateFrames('statusBarColor')
								end,
								get = function(info)
									return unpack(iTFConfig.layout.colors.statusbar.main)
								end,
							},
						},
					},
					raidIcon = {
						name = 'Raid marker',
						type = 'group',
						order = 3,
						args = {
							size = {
								name = 'Size',
								desc = 'Icon size',
								type = 'range',
								order = 1,
								min = 5,
								max = 100,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.raidIcon.size = val
									iTF:updateFrames('raidIcon')
								end,
								get = function(info) return iTFConfig.layout.raidIcon.size end
							},
							textPosition = {
								name = 'Icon Position',
								desc = 'Icon Position',
								type = 'select',
								order = 2,
								values = {['TOPLEFT'] = 'Top left', ['TOPRIGHT'] = 'Top right', ['TOP'] = 'Top', ['LEFT'] = 'Left', ['CENTER'] = 'Center', ['RIGHT'] = 'Right', ['BOTTOMRIGHT'] = 'Bottom right', ['BOTTOMLEFT'] = 'Bottom left', ['BOTTOM'] = 'Bottom'},
								set = function(info,val)
									iTFConfig.layout.raidIcon.pos = val
									iTF:updateFrames('raidIcon')
								end,
								get = function(info) return iTFConfig.layout.raidIcon.pos end
							},
							horizontal = {
								name = 'Horizontal position',
								desc = 'Horizontal position',
								type = 'range',
								order = 3,
								min = -50,
								max = 50,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.raidIcon.x = val
									iTF:updateFrames('raidIcon')
								end,
								get = function(info) return iTFConfig.layout.raidIcon.x end
							},
							vertical = {
								name = 'Vertical position',
								desc = 'Vertical position',
								type = 'range',
								order = 4,
								min = -50,
								max = 50,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.raidIcon.y = val
									iTF:updateFrames('raidIcon')
								end,
								get = function(info) return iTFConfig.layout.raidIcon.y end
							},
						},
					},
				},
			},
			auras={
				name = 'Auras',
				type = 'group',
				order = 2,
				args = {
					icon = {
						name = 'Icon',
						type = 'group',
						order = 1,
						args = {
							height = {
								name = 'Height',
								desc = 'Icon Height',
								type = 'range',
								order = 1,
								min = 1,
								max = 60,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.icon.height = val
									iTF:updateFrames('auraIcon')
								end,
								get = function(info) return iTFConfig.layout.icon.height end
							},
							width = {
								name = 'Width',
								desc = 'Icon width',
								type = 'range',
								order = 2,
								min = 1,
								max = 60,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.icon.width = val
									iTF:updateFrames('auraIcon')
								end,
								get = function(info) return iTFConfig.layout.icon.width end
							},
							horizontal = {
								name = 'Horizontal position',
								desc = 'Horizontal position',
								type = 'range',
								order = 3,
								min = -50,
								max = 50,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.icon.x = val
									iTF:updateFrames('auraIcon')
								end,
								get = function(info) return iTFConfig.layout.icon.x end
							},
							vertical = {
								name = 'Vertical position',
								desc = 'Vertical position',
								type = 'range',
								order = 4,
								min = -50,
								max = 50,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.icon.y = val
									iTF:updateFrames('auraIcon')
								end,
								get = function(info) return iTFConfig.layout.icon.y end
							},
							position = {
								name = 'Icon position',
								desc = 'Icon position',
								type = 'select',
								order = 5,
								values = GetValues('all'),
								set = function(info,val)
									iTFConfig.layout.icon.pos = val
									iTF:updateFrames('auraIcon')
								end,
								get = function(info) return iTFConfig.layout.icon.pos end
							},
							grow = {
								name = 'Grow',
								desc = 'Grow',
								type = 'select',
								order = 6,
								values = GetValues('grow'),
								set = function(info,val)
									iTFConfig.layout.icon.grow = val
									iTF:updateFrames('auraIcon')
								end,
								get = function(info) return iTFConfig.layout.icon.grow end
							},
							maxAuras = {
								name = 'Max auras',
								desc = 'Max auras',
								type = 'range',
								order = 7,
								min = 1,
								max = 8,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.icon.max = val
									iTF:updateFrames('auraIcon')
								end,
								get = function(info) return iTFConfig.layout.icon.max end
							},
						},
					},
				},
			},
			indicators={
				name = 'Indicators',
				type = 'group',
				order = 3,
				args = {
					outOfCombat = {
						name = 'Out of combat',
						type = 'group',
						order = 1,
						args = {
							enable = {
								name = 'Enable',
								desc = 'Enable out of combat glow',
								order = 1,
								type = 'toggle',
								set = function(info,val) 
									iTFConfig.layout.conditionals.outOfCombat.enable = val 
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return iTFConfig.layout.conditionals.outOfCombat.enable end,
							},
							indicator = {
								name = 'Indicator',
								type = 'multiselect',
								order = 5,
								values = GetValues('ind'),
								set = function(info,k,v)
									if v then
										iTFConfig.layout.conditionals.outOfCombat.indicators[k] = v
									else
										iTFConfig.layout.conditionals.outOfCombat.indicators[k] = nil
									end								
									iTF:updateFrames('conditionals')
								end,
								get = function(info,k) return iTFConfig.layout.conditionals.outOfCombat.indicators[k] end,
							},
							color = {
								name = 'Color',
								type = 'color',
								order = 2,
								hasAlpha = true,
								set = function(info,r,g,b,a)
									iTFConfig.layout.conditionals.outOfCombat.color = {r,g,b,a}
									iTF:updateFrames('conditionals')
								end,
								get = function(info)
									return unpack(iTFConfig.layout.conditionals.outOfCombat.color or {1,1,1,1})
								end,
							},
							weight = {
								name = 'Weight',
								desc = 'Indicator weight, higher overrides lower',
								type = 'range',
								order = 3,
								min = 1,
								max = 100,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.conditionals.outOfCombat.weight = val
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return iTFConfig.layout.conditionals.outOfCombat.weight end
							},
							alpha = {
								name = 'Opacity',
								desc = 'Frame opacity',
								type = 'range',
								order = 4,
								min = 0,
								max = 100,
								hidden = function()
									if iTFConfig.layout.conditionals.outOfCombat.indicators.alpha then
										return false
									else
										return true
									end
								end,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.conditionals.outOfCombat.alpha = min(val/100, 1)
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return (iTFConfig.layout.conditionals.outOfCombat.alpha or 1)*100 end
							},
						},
					},
					targeting = {
						name = 'Current target',
						type = 'group',
						order = 2,
						args = {
							enable = {
								name = 'Enable',
								desc = 'Enable current target border',
								order = 1,
								type = 'toggle',
								set = function(info,val) 
									iTFConfig.layout.conditionals.currentTarget.enable = val
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return iTFConfig.layout.conditionals.currentTarget.enable end,
							},
							color = {
								name = 'Color',
								type = 'color',
								order = 2,
								hasAlpha = true,
								set = function(info,r,g,b,a)
									iTFConfig.layout.conditionals.currentTarget.color = {r,g,b,a}
									iTF:updateFrames('conditionals')
								end,
								get = function(info)
									return unpack(iTFConfig.layout.conditionals.currentTarget.color or {1,1,1,1})
								end,
							},
							indicator = {
								name = 'Indicator',
								desc = 'Place(s) to show',
								order = 5,
								type = 'multiselect',
								values = GetValues('ind'),
								set = function(info, k, v)
									if v then
										iTFConfig.layout.conditionals.currentTarget.indicators[k] = v
									else
										iTFConfig.layout.conditionals.currentTarget.indicators[k] = nil
									end
									iTF:updateFrames('conditionals')
								end,
								get = function(info, k)
									return iTFConfig.layout.conditionals.currentTarget.indicators[k]
								end,
							},
							weight = {
								name = 'Weight',
								desc = 'Indicator weight, higher overrides lower',
								type = 'range',
								order = 3,
								min = 1,
								max = 100,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.conditionals.currentTarget.weight = val
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return iTFConfig.layout.conditionals.currentTarget.weight end
							},
							alpha = {
								name = 'Opacity',
								desc = 'Frame opacity',
								type = 'range',
								order = 4,
								min = 0,
								max = 100,
								hidden = function()
									if iTFConfig.layout.conditionals.currentTarget.indicators.alpha then
										return false
									else
										return true
									end
								end,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.conditionals.currentTarget.alpha = min(val/100, 1)
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return (iTFConfig.layout.conditionals.currentTarget.alpha or 1)*100 end
							},
						},
					},
					focus = {
						name = 'Focus target',
						type = 'group',
						order = 2,
						args = {
							enable = {
								name = 'Enable',
								desc = 'Enable focus indicator',
								order = 1,
								type = 'toggle',
								set = function(info,val) 
									iTFConfig.layout.conditionals.focusTarget.enable = val
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return iTFConfig.layout.conditionals.focusTarget.enable end,
							},
							color = {
								name = 'Color',
								type = 'color',
								order = 2,
								hasAlpha = true,
								set = function(info,r,g,b,a)
									iTFConfig.layout.conditionals.focusTarget.color = {r,g,b,a}
									iTF:updateFrames('conditionals')
								end,
								get = function(info)
									return unpack(iTFConfig.layout.conditionals.focusTarget.color or {1,1,1,1})
								end,
							},
							indicator = {
								name = 'Indicator',
								desc = 'Place(s) to show',
								order = 5,
								type = 'multiselect',
								values = GetValues('ind'),
								set = function(info, k, v)
									if v then
										iTFConfig.layout.conditionals.focusTarget.indicators[k] = v
									else
										iTFConfig.layout.conditionals.focusTarget.indicators[k] = nil
									end
									iTF:updateFrames('conditionals')
								end,
								get = function(info, k)
									return iTFConfig.layout.conditionals.focusTarget.indicators[k]
								end,
							},
							weight = {
								name = 'Weight',
								desc = 'Indicator weight, higher overrides lower',
								type = 'range',
								order = 3,
								min = 1,
								max = 100,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.conditionals.focusTarget.weight = val
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return iTFConfig.layout.conditionals.focusTarget.weight end
							},
							alpha = {
								name = 'Opacity',
								desc = 'Frame opacity',
								type = 'range',
								order = 4,
								min = 0,
								max = 100,
								hidden = function()
									if iTFConfig.layout.conditionals.focusTarget.indicators.alpha then
										return false
									else
										return true
									end
								end,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.conditionals.focusTarget.alpha = min(val/100, 1)
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return (iTFConfig.layout.conditionals.focusTarget.alpha or 1)*100 end
							},
						},
					},
					interruptRange = {
						name = 'Interrupt range',
						type = 'group',
						order = 5,
						args = {
							enable = {
								name = 'Enable',
								desc = 'Enable interrupt range indicator',
								order = 1,
								type = 'toggle',
								set = function(info,val)
									iTFConfig.layout.conditionals.interruptRange.enable = val
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return iTFConfig.layout.conditionals.interruptRange.enable end,
							},
							color = {
								name = 'Color',
								type = 'color',
								order = 3,
								hasAlpha = true,
								set = function(info,r,g,b,a)
									iTFConfig.layout.conditionals.interruptRange.color = {r,g,b,a}
									iTF:updateFrames('interruptRange')
								end,
								get = function(info)
									return unpack(iTFConfig.layout.conditionals.interruptRange.color or {1,1,1,1})
								end,
							},
							indicator = {
								name = 'Indicator',
								desc = 'Place(s) to show',
								order = 5,
								type = 'multiselect',
								values = GetValues('ind'),
								set = function(info, k, v)
									if v then
										iTFConfig.layout.conditionals.interruptRange.indicators[k] = v
									else
										iTFConfig.layout.conditionals.interruptRange.indicators[k] = nil
									end
									iTF:updateFrames('conditionals')
								end,
								get = function(info, k)
									return iTFConfig.layout.conditionals.interruptRange.indicators[k]
								end,
							},
							weight = {
								name = 'Weight',
								desc = 'Indicator weight, higher overrides lower',
								type = 'range',
								order = 3,
								min = 1,
								max = 100,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.conditionals.interruptRange.weight = val
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return iTFConfig.layout.conditionals.interruptRange.weight end
							},
							alpha = {
								name = 'Opacity',
								desc = 'Frame opacity',
								type = 'range',
								order = 4,
								min = 0,
								max = 100,
								hidden = function()
									if iTFConfig.layout.conditionals.interruptRange.indicators.alpha then
										return false
									else
										return true
									end
								end,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.conditionals.interruptRange.alpha = min(val/100, 1)
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return (iTFConfig.layout.conditionals.interruptRange.alpha or 1)*100 end
							},
						},
					},
					DPSrange = {
						name = 'Max range (DPS)',
						type = 'group',
						order = 3,
						args = {
							enable = {
								name = 'Enable',
								desc = 'Enable max range (DPS) indicator',
								order = 1,
								type = 'toggle',
								set = function(info,val) 
									iTFConfig.layout.conditionals.maxRangeDPS.enable = val
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return iTFConfig.layout.conditionals.maxRangeDPS.enable end,
							},
							color = {
								name = 'Color',
								type = 'color',
								order = 3,
								hasAlpha = true,
								set = function(info,r,g,b,a)
									iTFConfig.layout.conditionals.maxRangeDPS.color = {r,g,b,a}
									iTF:updateFrames('maxRange')
								end,
								get = function(info)
									return unpack(iTFConfig.layout.conditionals.maxRangeDPS.color or {1,1,1,1})
								end,
							},
							indicator = {
								name = 'Indicator',
								desc = 'Place(s) to show',
								order = 5,
								type = 'multiselect',
								values = GetValues('ind'),
								set = function(info, k, v)
									if v then
										iTFConfig.layout.conditionals.maxRangeDPS.indicators[k] = v
									else
										iTFConfig.layout.conditionals.maxRangeDPS.indicators[k] = nil
									end
									iTF:updateFrames('conditionals')
								end,
								get = function(info, k)
									return iTFConfig.layout.conditionals.maxRangeDPS.indicators[k]
								end,
							},
							weight = {
								name = 'Weight',
								desc = 'Indicator weight, higher overrides lower',
								type = 'range',
								order = 3,
								min = 1,
								max = 100,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.conditionals.maxRangeDPS.weight = val
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return iTFConfig.layout.conditionals.maxRangeDPS.weight end
							},
							alpha = {
								name = 'Opacity',
								desc = 'Frame opacity',
								type = 'range',
								order = 4,
								min = 0,
								max = 100,
								hidden = function()
									if iTFConfig.layout.conditionals.maxRangeDPS.indicators.alpha then
										return false
									else
										return true
									end
								end,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.conditionals.maxRangeDPS.alpha = min(val/100, 1)
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return (iTFConfig.layout.conditionals.maxRangeDPS.alpha or 1)*100 end
							},
						},
					},
					range = {
						name = 'Max range (Utility)',
						type = 'group',
						order = 4,
						args = {
							enable = {
								name = 'Enable',
								desc = 'Enable max range (Utility) indicator',
								order = 1,
								type = 'toggle',
								set = function(info,val) 
									iTFConfig.layout.conditionals.maxRange.enable = val
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return iTFConfig.layout.conditionals.maxRange.enable end,
							},
							color = {
								name = 'Color',
								type = 'color',
								order = 3,
								hasAlpha = true,
								set = function(info,r,g,b,a)
									iTFConfig.layout.conditionals.maxRange.color = {r,g,b,a}
									iTF:updateFrames('maxRange')
								end,
								get = function(info)
									return unpack(iTFConfig.layout.conditionals.maxRange.color or {1,1,1,1})
								end,
							},
							indicator = {
								name = 'Indicator',
								desc = 'Place(s) to show',
								order = 5,
								type = 'multiselect',
								values = GetValues('ind'),
								set = function(info, k, v)
									if v then
										iTFConfig.layout.conditionals.maxRange.indicators[k] = v
									else
										iTFConfig.layout.conditionals.maxRange.indicators[k] = nil
									end
									iTF:updateFrames('conditionals')
								end,
								get = function(info, k)
									return iTFConfig.layout.conditionals.maxRange.indicators[k]
								end,
							},
							weight = {
								name = 'Weight',
								desc = 'Indicator weight, higher overrides lower',
								type = 'range',
								order = 3,
								min = 1,
								max = 100,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.conditionals.maxRange.weight = val
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return iTFConfig.layout.conditionals.maxRange.weight end
							},
							alpha = {
								name = 'Opacity',
								desc = 'Frame opacity',
								type = 'range',
								order = 4,
								min = 0,
								max = 100,
								hidden = function()
									if iTFConfig.layout.conditionals.maxRange.indicators.alpha then
										return false
									else
										return true
									end
								end,
								step = 1,
								set = function(info,val)
									iTFConfig.layout.conditionals.maxRange.alpha = min(val/100, 1)
									iTF:updateFrames('conditionals')
								end,
								get = function(info) return (iTFConfig.layout.conditionals.maxRange.alpha or 1)*100 end
							},
						},
					},
					threat = {
						name = 'Threat',
						type = 'group',
						order = 6,
						args = {
							aggro = {
								name = 'Aggro',
								type = 'group',
								order = 1,
								args = {
									enable = {
									name = 'Enable',
									desc = 'Enable aggro indicator',
									order = 1,
									type = 'toggle',
									set = function(info,val) 
										iTFConfig.layout.conditionals.aggro.enable = val 
										iTF:updateFrames('conditionals')
									end,
									get = function(info) return iTFConfig.layout.conditionals.aggro.enable end,
									},
									indicator = {
										name = 'Indicator',
										type = 'multiselect',
										order = 5,
										values = GetValues('ind'),
										set = function(info,k,v)
											if v then
												iTFConfig.layout.conditionals.aggro.indicators[k] = v
											else
												iTFConfig.layout.conditionals.aggro.indicators[k] = nil
											end								
											iTF:updateFrames('conditionals')
										end,
										get = function(info,k) return iTFConfig.layout.conditionals.aggro.indicators[k] end,
									},
									color = {
										name = 'Color',
										type = 'color',
										order = 2,
										hasAlpha = true,
										set = function(info,r,g,b,a)
											iTFConfig.layout.conditionals.aggro.color = {r,g,b,a}
											iTF:updateFrames('conditionals')
										end,
										get = function(info)
											return unpack(iTFConfig.layout.conditionals.aggro.color or {1,1,1,1})
										end,
									},
									weight = {
										name = 'Weight',
										desc = 'Indicator weight, higher overrides lower',
										type = 'range',
										order = 3,
										min = 1,
										max = 100,
										step = 1,
										set = function(info,val)
											iTFConfig.layout.conditionals.aggro.weight = val
											iTF:updateFrames('conditionals')
										end,
										get = function(info) return iTFConfig.layout.conditionals.aggro.weight end
									},
									alpha = {
										name = 'Opacity',
										desc = 'Frame opacity',
										type = 'range',
										order = 4,
										min = 0,
										max = 100,
										hidden = function()
											if iTFConfig.layout.conditionals.aggro.alpha then
												return false
											else
												return true
											end
										end,
										step = 1,
										set = function(info,val)
											iTFConfig.layout.conditionals.aggro.alpha = min(val/100, 1)
											iTF:updateFrames('conditionals')
										end,
										get = function(info) return (iTFConfig.layout.conditionals.aggro.alpha or 1)*100 end
									},
									roles = {
										name = 'Roles', 
										desc = 'Show when roles is',
										order = 7,
										type = 'select',
										values = {'All', 'Tank', 'Dps/Healer'},
										set = function(info,val)
											iTFConfig.layout.conditionals.aggro.roles = val
												iTF:updateFrames('conditionals')
										end,
										get = function(info) return iTFConfig.layout.conditionals.aggro.roles end
									},
								},
							},
							losingAggro = {
								name = 'Losing aggro',
								type = 'group',
								order = 2,
								args = {
									enable = {
									name = 'Enable',
									desc = 'Enable losing aggro indicator',
									order = 1,
									type = 'toggle',
									set = function(info,val) 
										iTFConfig.layout.conditionals.losingAggro.enable = val 
										iTF:updateFrames('conditionals')
									end,
									get = function(info) return iTFConfig.layout.conditionals.losingAggro.enable end,
									},
									indicator = {
										name = 'Indicator',
										type = 'multiselect',
										order = 5,
										values = GetValues('ind'),
										set = function(info,k,v)
											if v then
												iTFConfig.layout.conditionals.losingAggro.indicators[k] = v
											else
												iTFConfig.layout.conditionals.losingAggro.indicators[k] = nil
											end								
											iTF:updateFrames('conditionals')
										end,
										get = function(info,k) return iTFConfig.layout.conditionals.losingAggro.indicators[k] end,
									},
									color = {
										name = 'Color',
										type = 'color',
										order = 2,
										hasAlpha = true,
										set = function(info,r,g,b,a)
											iTFConfig.layout.conditionals.losingAggro.color = {r,g,b,a}
											iTF:updateFrames('conditionals')
										end,
										get = function(info)
											return unpack(iTFConfig.layout.conditionals.losingAggro.color or {1,1,1,1})
										end,
									},
									weight = {
										name = 'Weight',
										desc = 'Indicator weight, higher overrides lower',
										type = 'range',
										order = 3,
										min = 1,
										max = 100,
										step = 1,
										set = function(info,val)
											iTFConfig.layout.conditionals.losingAggro.weight = val
											iTF:updateFrames('conditionals')
										end,
										get = function(info) return iTFConfig.layout.conditionals.losingAggro.weight end
									},
									alpha = {
										name = 'Opacity',
										desc = 'Frame opacity',
										type = 'range',
										order = 4,
										min = 0,
										max = 100,
										hidden = function()
											if iTFConfig.layout.conditionals.losingAggro.alpha then
												return false
											else
												return true
											end
										end,
										step = 1,
										set = function(info,val)
											iTFConfig.layout.conditionals.losingAggro.alpha = min(val/100, 1)
											iTF:updateFrames('conditionals')
										end,
										get = function(info) return (iTFConfig.layout.conditionals.losingAggro.alpha or 1)*100 end
									},
									roles = {
										name = 'Roles', 
										desc = 'Show when roles is',
										order = 7,
										type = 'select',
										values = {'All', 'Tank', 'Dps/Healer'},
										set = function(info,val)
											iTFConfig.layout.conditionals.losingAggro.roles = val
												iTF:updateFrames('conditionals')
										end,
										get = function(info) return iTFConfig.layout.conditionals.losingAggro.roles end
									},
								},
							},
							gainingAggro = {
								name = 'Gaining aggro',
								type = 'group',
								order = 1,
								args = {
									enable = {
									name = 'Enable',
									desc = 'Enable gaining aggro indicator',
									order = 1,
									type = 'toggle',
									set = function(info,val) 
										iTFConfig.layout.conditionals.gainingAggro.enable = val 
										iTF:updateFrames('conditionals')
									end,
									get = function(info) return iTFConfig.layout.conditionals.gainingAggro.enable end,
									},
									indicator = {
										name = 'Indicator',
										type = 'multiselect',
										order = 5,
										values = GetValues('ind'),
										set = function(info,k,v)
											if v then
												iTFConfig.layout.conditionals.gainingAggro.indicators[k] = v
											else
												iTFConfig.layout.conditionals.gainingAggro.indicators[k] = nil
											end								
											iTF:updateFrames('conditionals')
										end,
										get = function(info,k) return iTFConfig.layout.conditionals.gainingAggro.indicators[k] end,
									},
									color = {
										name = 'Color',
										type = 'color',
										order = 2,
										hasAlpha = true,
										set = function(info,r,g,b,a)
											iTFConfig.layout.conditionals.gainingAggro.color = {r,g,b,a}
											iTF:updateFrames('conditionals')
										end,
										get = function(info)
											return unpack(iTFConfig.layout.conditionals.gainingAggro.color or {1,1,1,1})
										end,
									},
									weight = {
										name = 'Weight',
										desc = 'Indicator weight, higher overrides lower',
										type = 'range',
										order = 3,
										min = 1,
										max = 100,
										step = 1,
										set = function(info,val)
											iTFConfig.layout.conditionals.gainingAggro.weight = val
											iTF:updateFrames('conditionals')
										end,
										get = function(info) return iTFConfig.layout.conditionals.gainingAggro.weight end
									},
									alpha = {
										name = 'Opacity',
										desc = 'Frame opacity',
										type = 'range',
										order = 4,
										min = 0,
										max = 100,
										hidden = function()
											if iTFConfig.layout.conditionals.gainingAggro.alpha then
												return false
											else
												return true
											end
										end,
										step = 1,
										set = function(info,val)
											iTFConfig.layout.conditionals.gainingAggro.alpha = min(val/100, 1)
											iTF:updateFrames('conditionals')
										end,
										get = function(info) return (iTFConfig.layout.conditionals.gainingAggro.alpha or 1)*100 end
									},
									roles = {
										name = 'Roles', 
										desc = 'Show when roles is',
										order = 7,
										type = 'select',
										values = {'All', 'Tank', 'Dps/Healer'},
										set = function(info,val)
											iTFConfig.layout.conditionals.gainingAggro.roles = val
												iTF:updateFrames('conditionals')
										end,
										get = function(info) return iTFConfig.layout.conditionals.gainingAggro.roles end
									},
								},
							},
						},
					},
					--[=[
					custom = {
						name = 'Custom conditionals',
						type = 'group',
						order = 7,
						args = {
							name = {
								name = 'Name',
								desc = 'custom conditional name',
								order = 1,
								type = 'input',
								set = function(info,val) 
									customCondTemp.name = val
								end,
								get = function(info) return customCondTemp.name or '' end,
							},
							updateType = {
								name = 'Update on',
								desc = 'When to update',
								order = 2,
								type = 'select',
								values = {'onUpdate (0.2sec)','UNIT_AURA', 'Cast start', 'Health update', 'Player target changed', 'Threat update'},
								set = function(info,val) 
									customCondTemp.updateType = val
								end,
								get = function(info) return customCondTemp.updateType or 1 end,
							},
							color = {
								name = 'Color',
								type = 'color',
								order = 3,
								hasAlpha = true,
								set = function(info,r,g,b,a)
									customCondTemp.color = {r,g,b,a}
								end,
								get = function(info)
									return unpack(customCondTemp.color or {1,1,1,1})
								end,
							},
							indicator = {
								name = 'Indicator',
								desc = 'Place(s) to show',
								order = 5,
								type = 'multiselect',
								values = GetValues('ind'),
								set = function(info, k, v)
									if not customCondTemp.indicators[k] then
										customCondTemp.indicators = {}
									end
									if v then
										customCondTemp.indicators[k] = v
									else
										customCondTemp.indicators[k] = nil
									end
								end,
								get = function(info, k)
									if not customCondTemp.indicators then customCondTemp.indicators = {} end
									return customCondTemp.indicators[k]
								end,
							},
							weight = {
								name = 'Weight',
								desc = 'Indicator weight, higher overrides lower',
								type = 'range',
								order = 3,
								min = 1,
								max = 100,
								step = 1,
								set = function(info,val)
									customCondTemp.weight = val
								end,
								get = function(info) return customCondTemp.weight end
							},
							alpha = {
								name = 'Opacity',
								desc = 'Frame opacity',
								type = 'range',
								order = 4,
								min = 0,
								max = 100,
								hidden = function()
									if customCondTemp.indicators then
										if customCondTemp.indicators.alpha then
											return false
										else
											return true
										end
									else
										return true
									end
								end,
								step = 1,
								set = function(info,val)
									customCondTemp.alpha = min(val/100, 1)
								end,
								get = function(info) return (customCondTemp.alpha or 1)*100 end
							},
							addNew = {
								name = 'Add New',
								desc = 'Add New Custom Condtional',
								type = 'execute',
								width = 'full',
								order = 10,
								func = function()
									local name = customCondTemp.name
									customCondTemp.name = nil
									iTFConfig.conditionals.custom[name] = customCondTemp
									customCondTemp = nil
									customCondTemp = {}
								end,
							},
						},
					}, --]=]
				},
			},
			bindings={
				name = 'Bindings',
				type = 'group',
				order = 4,
				args = {
					general = {
						name = 'General', 
						desc = 'General bindings',
						order = 1,
						type = 'group',
						args = getArgs('general'),
					},
					class = {
						name = 'Class', 
						desc = 'Class specific bindings',
						order = 2,
						type = 'group',
						args = getArgs('class'),
					},
					spec = {
						name = 'Spec',
						desc = 'Specialization specific bindings',
						order = 3,
						type = 'group',
						args = getArgs('spec'),
					},
				},
			},
			layouts={
				name = 'Layouts',
				type = 'group',
				order = 5,
				args = {
					profiles = {
						name = 'Load layout', 
						order = 1,
						type = 'select',
						values = GetProfiles(),
						confirm = true,
						confirmText = 'Are you sure? This will delete your current settings.',
						set = function(info,val)
							iTFConfig.layout = iTF:GetProfile(profileListing[val])
							iTF:updateFrames()
							iTF:print('Loaded: "' .. profileListing[val] .. '" profile.')
						end,
						get = function(info) return false end
					},
				},
			},
		},
	}
	return options
end

local AceConfigDialog = LibStub('AceConfigDialog-3.0')
LibStub('AceConfig-3.0'):RegisterOptionsTable('iTargetingFrames', iTF:loadOptions())
AceConfigDialog:SetDefaultSize('iTargetingFrames', 600,500)
function iTF:toggleConfig(hide)
	iTF:loadOptions()
	AceConfigDialog:Open('iTargetingFrames')
end