local _, iTF = ...
local maxRanges = {
	--Death Knight
	[250] = { --Blood
		d = 49576,	--Death Grip (30yd)
		i = 47528,	--Mind Freeze (15yd)
		m = 49998,	--Death Strike (Melee)
		t = true,	--Tank
	},
	[251] = { --Frost
		d = 49576,	--Death Grip (30yd)
		i = 47528,	--Mind Freeze (15yd)
		m = 49143,	--Frost Strike (Melee)
	},
	[252] = { --Unholy,
		d = 49576,	--Death Grip (30yd)
		i = 47528,	--Mind Freeze (15yd)
		m = 55090,	--Scourge Strike (Melee)
	},

	--Demon Hunter
	[577] = { --Havoc
		d = 185123,	--Throw Glaive (30yd)
		i = 183752,	--Consume Magic (20yd)
		m = 162794,	--Chaos Strike (Melee)
	},
	[581] = { --Vengeance
		d = 185245,	--Torment (30yd)
		i = 183752,	--Consume Magic (20yd)
		m = 203798,	--Soul Cleave (Melee)
		t = true,	--Tank
	},

	--Druid
	[102] = { --Balance
		d = 190984,	--Solar Wrath (45yd)
		i = 78675,	--Solar Beam (45yd)
		m = 190984,	--Solar Wrath (45yd)
	},
	[103] = { --Feral,
		d = 8921,	--Moonfire (40yd)
		i = 106839,	--Skull Bash (13yd+)
		m = 5221,	--Shred (Melee)
	},
	[104] = { --Guardian
		d = 6795,	--Growl (30yd)
		i = 106839,	--Skull Bash (13yd+)
		m = 6807,	--Maul (Melee)
		t = true,	--Tank
	},
	[105] = { --Restoration
		d = 5176,	--Solar Wrath (40yd)
		m = 5176,	--Solar Wrath (40yd)
	},

	--Hunter
	[253] = { --Beastmastery
		d = 193455,	--Cobra Shot (40yd)
		i = 147362,	-- Counter Shot (40yd)
		m = 193455,	--Cobra Shot (40yd)
	},
	[254] = { --Marksmanship
		d = 185901,	--Marked Shot (40yd+)
		i = 147362,	-- Counter Shot (40yd)
		m = 185901,	--Marked Shot (40yd+)
	},
	[255] = {--Survival
		d = {
			min = 185855,	--Lacerate (<5yd)
			max = 190925,	--Harpoon (5-40yd)
			},
		i = 187707,	--Muzzle (5yd)
		m = 185855,	--Lacerate (5yd)
	},
	--Mage
	[62] = { --Arcane
		d = 30451,	--Arcane Blast (40yd)
		i = 2139,	--Counterspell (40yd)
		m = 30451,	--Arcane Blast (40yd)
	},
	[63] = { --Fire
		d = 133,	--Fireball (40yd)
		i = 2139,	--Counterspell (40yd)
		m = 133,	--Fireball (40yd)
	},
	[64] = { --Frost
		d = 116,	--Frostbolt (40yd)
		i = 2139,	--Counterspell (40yd)
		m = 116,	--Frostbolt (40yd)
	},

	--Monk
	[268] = { --Brewmaster
		d = 115546,	--Provoke (30yd)
		i = 116705,	--Spear Hand Strike (Melee)
		m = 205523, --Blackout Kick (Melee)
		t = true,	--Tank
	},
	[269] = { --Windwalker
		d = 115546,	--Provoke (30yd)
		i = 116705,	--Spear Hand Strike (Melee)
		m = 107428,	--Rising Sun Kick (Melee)
	},
	[270] = { --Mistviewer
		d = 115546,	--Provoke (30yd)
		m = 117952,	--Crackling Jade Lightning (40yd), TO DO: maybe switch to melee ability?
	},

	--Paladin
	[65] = { --Holy
		d = 62124,	--Hand of Reckoning (30yd)
		m = 20271,	--Judgment (30yd), TO DO: maybe switch to melee ability? (or Holy Shock, 40yd)
	},
	[66] = { --Protection
		d = 62124,	--Hand of Reckoning (30yd)
		i = 96231,	--Rebuke (Melee)
		m = 53600,	--Shield of the Righteous (30yd)
		t = true,	--Tank
	},
	[70] = { --Retribution
		d = 62124,	--Hand of Reckoning (30yd)
		i = 96231,	--Rebuke (Melee)
		m = 35395,	--Crusader Strike
	},
	--Priest
	
	[256] = { --Discipline
		d = 585,	--Smite (40yd)
		m = 585,	--Smite (40yd)
	},
	[257] = { --Holy
		d = 585,	--Smite (40yd)
		m = 585,	--Smite (40yd)
	},
	[258] = { --Shadow
		d = 589,	--Shadow Word: Pain (40yd)
		i = 15487,	-- Silence (30yd)
		m = 589,	--Shadow Word: Pain (40yd)
	},

	--Rogue
	[259] = { --Assassination
		d =36554,	--Shadowstep (25yd)
		i = 1766,	--Kick (Melee)
		m = 1329,	--Mutilate (Melee)
	},
	[260] = { --Outlaw
		d = 185763,	--Pistol Shot (20yd)
		i = 1766,	--Kick (Melee)
		m = 193315,	--Saber Slash (Melee)
	},
	[261] = { --Sublety
		d = 36554,	--Shadowstep (25yd)
		i = 1766,	--Kick (Melee)
		m = 52,		--Backstab (Melee)
	},

	--Shaman
	[262] = { --Elemental
		d = 188196,	--Lightning Bolt (40yd)
		i = 57994,	--Wind Shear (30yd)
		m = 188196,	--Lightning Bolt (40yd)
	},
	[263] = { --Enhancement
		d = 187837,	--Lightning Bolt (40yd)
		i = 57994,	--Wind Shear (30yd)
		m = 17364,	--Stormstrike (Melee)
	},
	[264] = { --Restoration
		d = 188838,	--Flame Shock (40yd)
		i = 57994,	--Wind Shear (30yd)
		m = 188838,	--Flame Shock (40yd)
	},

	--Warlock --TO DO: add pets
	[265] = { --Affliction
		d = 172,	--Corruption (40yd)
		m = 172,	--Corruption (40yd)
	},
	[266] = { --Demonology
		d = 686,	--Shadow Bolt (40yd)
		m = 686,	--Shadow Bolt (40yd)
	},
	[267] = { --Descrution
		d = 29722,	--Incinerate (40yd)
		m = 29722,	--Incinerate (40yd)
	},

	--Warrior
	[71] = { --Arms
		d = 355,	--Taunt (30yd)
		i = 6552,	--Pummel (Melee)
		m = 12294,	--Mortal Strike (Melee)
	},
	[72] = { --Fury
		d = 355,	--Taunt (30yd)
		i = 6552,	--Pummel (Melee)
		m = 23881,	--Bloodthirst (Melee)
	},
	[73] = { --Protection
		d = 355,	--Taunt (30yd)
		i = 6552,	--Pummel (Melee)
		m = 20243,	--Devastate (Melee)
		t = true,	--Tank
	},

}
local function convertIdsToNames(t)
	local temp = {}
	for k,v in pairs(maxRanges) do
		if type(v) == 'table' then
			temp[k] = {}
			for dK,dV in pairs(v) do
				if type(dV) == 'table' then
					temp[k][dK] = {}
					for iK, iV in pairs(dV) do
						temp[k][dK][iK] = GetSpellInfo(iV)
					end
				else
					temp[k][dK] = GetSpellInfo(dV)
				end
			end
		else
			temp[k] = GetSpellInfo(v)
		end
	end
	return temp
end
iTF.spells = {
	['range'] = convertIdsToNames(maxRanges),
}